﻿Imports C1.Silverlight.DataGrid

Partial Public Class MainPage
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
        SetInf()
    End Sub

    Private Sub SetInf()
        _DataGrid.ShowVerticalFreezingSeparator = DataGridColumnFreezing.Left
        _DataGrid.FrozenColumnCount = 1
        _DataGrid.CanUserAddRows = False
        Dim _Data As List(Of ListInf) = New List(Of ListInf)
        Dim i As Integer = 0
        Do While (i < 20)

            Dim LInf As New ListInf
            LInf.col_1 = "data1"
            LInf.col_2 = "data2"
            LInf.col_3 = "data3"
            LInf.col_4 = "data4"
            LInf.col_5 = "data5"
            LInf.col_6 = "data6"
            LInf.col_7 = "data7"
            LInf.col_8 = "data8"
            LInf.col_9 = "data9"
            LInf.col_10 = "data10"

            _Data.Add(LInf)
            i = (i + 1)
        Loop

        _DataGrid.ItemsSource = _Data
        AddHandler _DataGrid.LoadedRowPresenter, AddressOf Me._DataGrid_LoadedRowPresenter
        AddHandler _DataGrid.LoadedCellPresenter, AddressOf Me._DataGrid_LoadedCellPresenter
        AddHandler _DataGrid.UnloadedCellPresenter, AddressOf Me._DataGrid_UnloadedCellPresenter
        AddHandler _DataGrid.UnloadedRowPresenter, AddressOf Me._DataGrid_UnloadedRowPresenter

    End Sub


    Private Sub _DataGrid_LoadedCellPresenter(sender As Object, e As C1.Silverlight.DataGrid.DataGridCellEventArgs)
        Dim cell As DataGridCell = e.Cell
        If cell.Presenter IsNot Nothing AndAlso cell.Column.DisplayIndex = 8 Then
            If cell.Row.Index Mod 2 = 0 Then
                cell.Presenter.Foreground = New SolidColorBrush(Colors.Red)
            End If
        End If
    End Sub

    Private Sub _DataGrid_LoadedRowPresenter(sender As Object, e As C1.Silverlight.DataGrid.DataGridRowEventArgs)
        If Not e.Row.Index Mod 2 = 0 Then
            e.Row.Presenter.Background = New SolidColorBrush(Colors.Green)
        End If
    End Sub

    Private Sub _DataGrid_UnloadedCellPresenter(sender As Object, e As C1.Silverlight.DataGrid.DataGridCellEventArgs)

        e.Cell.Presenter.Foreground = _DataGrid.Foreground
    End Sub

    Private Sub _DataGrid_UnloadedRowPresenter(sender As Object, e As C1.Silverlight.DataGrid.DataGridRowEventArgs)
        ' Reset the Row Background to orignal backcolor
        If ((e.Row.Index Mod 2) _
                    = 0) Then
            e.Row.Presenter.Background = _DataGrid.RowBackground
        Else
            e.Row.Presenter.Background = _DataGrid.AlternatingRowBackground
        End If
    End Sub
End Class

Public Class ListInf

    Private _col_1 As String

    Public Property col_1 As String
        Get
            Return _col_1
        End Get
        Set(value As String)
            _col_1 = value
        End Set
    End Property

    Private _col_2 As String

    Public Property col_2 As String
        Get
            Return _col_2
        End Get
        Set(value As String)
            _col_2 = value
        End Set
    End Property

    Private _col_3 As String

    Public Property col_3 As String
        Get
            Return _col_3
        End Get
        Set(value As String)
            _col_3 = value
        End Set
    End Property

    Private _col_4 As String

    Public Property col_4 As String
        Get
            Return _col_4
        End Get
        Set(value As String)
            _col_4 = value
        End Set
    End Property

    Private _col_5 As String

    Public Property col_5 As String
        Get
            Return _col_5
        End Get
        Set(value As String)
            _col_5 = value
        End Set
    End Property

    Private _col_6 As String

    Public Property col_6 As String
        Get
            Return _col_6
        End Get
        Set(value As String)
            _col_6 = value
        End Set
    End Property

    Private _col_7 As String

    Public Property col_7 As String
        Get
            Return _col_7
        End Get
        Set(value As String)
            _col_7 = value
        End Set
    End Property

    Private _col_8 As String

    Public Property col_8 As String
        Get
            Return _col_8
        End Get
        Set(value As String)
            _col_8 = value
        End Set
    End Property

    Private _col_9 As String

    Public Property col_9 As String
        Get
            Return _col_9
        End Get
        Set(value As String)
            _col_9 = value
        End Set
    End Property

    Private _col_10 As String

    Public Property col_10 As String
        Get
            Return _col_10
        End Get
        Set(value As String)
            _col_10 = value
        End Set
    End Property
End Class